Module Start

    Public WithEvents oPM As cParManager
    Public WithEvents oCnM As cCnManager

    Public Enum eLog As Byte
        elManual
        el1Month
        el2Months
        el3Months
        el6Months
        elYear
    End Enum

    Public Enum Protocol As Byte
        epFTP
        epXML
    End Enum

    Public Enum Trigger As Byte
        etSchedule
        etExternal
    End Enum

    Public Function NumKeyOK(ByVal ASCIICode As Long, ByVal strText As String, ByVal intDecimals As Integer) As Boolean
        '********************************************************
        ' NumKeyOK
        ' Function to determine wether the last key pressed is acceptable when entering numeric values
        ' It accepts numeric keys (0...9), TAB, ENTER, and decimal separator if requested
        ' Parameters:
        '   - ASCIICode - the ASCII code of the key pressed
        '   - strText - the actual text in the textbox (used to determine wehter the decimal separator is already in the text)
        '   - intDecimal - number of decimals
        ' Returns: True if proper numeric key. False otherwise.
        ' Created: 14/02/2002; O.A.
        ' Modified: -
        ' *******************************************************

        Dim bReturn As Boolean          ' The return value
        Dim intDecPos As Short        ' The decimal separator position within the text
        Dim gcDecSep As String = Format(0.1).Substring(2, 1)

        intDecPos = strText.IndexOf(".")
        If intDecPos = 0 Then intDecPos = strText.IndexOf(",")
        Select Case ASCIICode
            Case 8                      ' BACKSPACE
                bReturn = True
            Case 13                     ' RETURN
                bReturn = True
            Case 9                     ' TAB
                bReturn = True
            Case 48 To 57
                bReturn = True
            Case 44                     ' Decimal separator
                If gcDecSep = "," Then
                    If intDecimals > 0 Then
                        bReturn = (intDecPos = 0)
                    Else
                        bReturn = False     ' No decimal
                    End If
                Else
                    bReturn = False
                End If
            Case 46                     ' Decimal separator
                If gcDecSep = "." Then
                    If intDecimals > 0 Then
                        bReturn = (intDecPos = 0)
                    Else
                        bReturn = False     ' No decimal
                    End If
                Else
                    bReturn = False
                End If
            Case Else
                bReturn = False
        End Select
        NumKeyOK = bReturn
    End Function
End Module

