Imports System.IO
Imports System.Drawing
Imports System.IO.File
Imports System.Drawing.Printing

Public Class cLog

    Private WithEvents oDoc As PrintDocument
    Private oFile As StreamReader

    Public Sub AddToLog(ByVal Record As String, ByVal FileName As String)
        Dim WriteStream As StreamWriter

        Try
            WriteStream = File.AppendText(FileName)
            WriteStream.WriteLine(Format(Now) & " " & Record)
        Catch err As Exception
            MsgBox("Error while writing connections to file! " & err.Message, MsgBoxStyle.DefaultButton1 + MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "TransData v1.00 (alpha)")
        Finally
            WriteStream.Close()
        End Try
    End Sub

    Public Sub DeleteBefore(ByVal Moment As Date, ByVal FileName As String)
        Dim oRS As StreamReader
        Dim oWS As StreamWriter
        Dim strLine, strTmp As String
        Dim strTempFile As String = "C:\FTP_TMP.txt"

        If Dir(FileName).Length > 0 Then
            Try
                oRS = File.OpenText(FileName)
                If Dir(strTempFile).Length > 0 Then File.Delete(strTempFile)
                oWS = File.CreateText(strTempFile)
                strLine = oRS.ReadLine
                If Not IsNothing(strLine) Then
                    strTmp = strLine.Substring(0, 19)
                    If Not IsDate(strTmp) Then strTmp = "01-01-1601 00:00:01" ' just to be sure...
                Else
                    strTmp = "01-01-1601 00:00:01"
                End If
                Do While (Not IsNothing(strLine)) And (CDate(strTmp) <= Moment)
                    strLine = oRS.ReadLine
                    If Not IsNothing(strLine) Then
                        strTmp = strLine.Substring(0, 19)
                        If Not IsDate(strTmp) Then strTmp = "01-01-1601 00:00:01" ' just to be sure...
                    Else
                        strTmp = "01-01-1601 00:00:01"
                    End If
                Loop
                Do While Not IsNothing(strLine)
                    oWS.WriteLine(strLine)
                    strLine = oRS.ReadLine()
                Loop
            Catch eof As IO.EndOfStreamException
                'nothing to do here
            Catch err As Exception
                MsgBox("Error occurred while cleaning log file! - " & err.Message, MsgBoxStyle.DefaultButton1 + MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "TransData v1.00 (alpha)")
            Finally
                oRS.Close()
                oWS.Close()
                File.Delete(FileName)
                If Dir(strTempFile).Length > 0 Then
                    File.Move(strTempFile, FileName)
                End If
            End Try
        End If
    End Sub

    Public Sub DeleteLog(ByVal FileName As String)
        If Dir(FileName).Length > 0 Then File.Delete(FileName)
    End Sub

    Public Sub PrintLog(ByVal FileName As String)

        If Dir(FileName).Length > 0 Then
            Try
                oFile = File.OpenText(FileName)
                oDoc = New PrintDocument()
                oDoc.Print()
            Catch err As Exception
                MsgBox("Error occurred while printing log! - " & err.Message, MsgBoxStyle.DefaultButton1 + MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "TransData v1.00 (alpha)")
            End Try
        End If
    End Sub

    Private Sub oDoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles oDoc.PrintPage
        Dim sngcurY As Single
        Dim sngLineHeight As Single
        Dim oFont As Font

        oFont = New System.Drawing.Font("Courier New ", 12)
        sngLineHeight = oFont.GetHeight(e.Graphics)
        sngcurY = e.MarginBounds.Top
        If oFile.Peek <> 1 Then
            Do
                ' Move to next line
                sngcurY += sngLineHeight
                e.Graphics.DrawString(oFile.ReadLine, oFont, Brushes.Black, e.MarginBounds.Left, sngcurY)
            Loop Until ((sngcurY >= e.MarginBounds.Bottom) Or (oFile.Peek = -1))
        End If

        ' See wether we should carry on printing next page...
        e.HasMorePages = (oFile.Peek <> -1)
    End Sub
End Class
